# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .assistant_hook_filter import AssistantHookFilter
from .assistant_hook_action_base import AssistantHookActionBase
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AssistantHooks(UncheckedBaseModel):
    on: typing.Literal["call.ending"] = pydantic.Field(default="call.ending")
    """
    This is the event that triggers this hook
    """

    filters: typing.Optional[typing.List[AssistantHookFilter]] = pydantic.Field(default=None)
    """
    This is the set of filters that must match for the hook to trigger
    """

    do: typing.List[AssistantHookActionBase] = pydantic.Field()
    """
    This is the set of actions to perform when the hook triggers
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
