# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .fallback_open_ai_transcriber_model import FallbackOpenAiTranscriberModel
from .fallback_open_ai_transcriber_language import FallbackOpenAiTranscriberLanguage
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FallbackOpenAiTranscriber(UncheckedBaseModel):
    provider: typing.Literal["openai"] = pydantic.Field(default="openai")
    """
    This is the transcription provider that will be used.
    """

    model: FallbackOpenAiTranscriberModel = pydantic.Field()
    """
    This is the model that will be used for the transcription.
    """

    language: typing.Optional[FallbackOpenAiTranscriberLanguage] = pydantic.Field(default=None)
    """
    This is the language that will be set for the transcription.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
