# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
import typing_extensions
from .vapi_voice_voice_id import VapiVoiceVoiceId
from ..core.serialization import FieldMetadata
from .vapi_voice_language import VapiVoiceLanguage
from .chunk_plan import ChunkPlan
from .fallback_plan import FallbackPlan
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class VapiVoice(UncheckedBaseModel):
    provider: typing.Literal["vapi"] = pydantic.Field(default="vapi")
    """
    This is the voice provider that will be used.
    """

    voice_id: typing_extensions.Annotated[VapiVoiceVoiceId, FieldMetadata(alias="voiceId")] = pydantic.Field()
    """
    The voices provided by Vapi
    """

    speed: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the speed multiplier that will be used.
    
    @default 1
    """

    language: typing.Optional[VapiVoiceLanguage] = pydantic.Field(default=None)
    """
    This is the language code (ISO 639-1) that will be used.
    
    @default 'en-US'
    """

    chunk_plan: typing_extensions.Annotated[typing.Optional[ChunkPlan], FieldMetadata(alias="chunkPlan")] = (
        pydantic.Field(default=None)
    )
    """
    This is the plan for chunking the model output before it is sent to the voice provider.
    """

    fallback_plan: typing_extensions.Annotated[typing.Optional[FallbackPlan], FieldMetadata(alias="fallbackPlan")] = (
        pydantic.Field(default=None)
    )
    """
    This is the plan for voice provider fallbacks in the event that the primary voice provider fails.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
