# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import typing_extensions
from .o_auth_2_authentication_plan import OAuth2AuthenticationPlan
from ..core.serialization import FieldMetadata
import pydantic
import datetime as dt
from .oauth_2_authentication_session import Oauth2AuthenticationSession
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class WebhookCredential(UncheckedBaseModel):
    provider: typing.Literal["webhook"] = "webhook"
    authentication_plan: typing_extensions.Annotated[
        OAuth2AuthenticationPlan, FieldMetadata(alias="authenticationPlan")
    ] = pydantic.Field()
    """
    This is the authentication plan. Currently supports OAuth2 RFC 6749.
    """

    id: str = pydantic.Field()
    """
    This is the unique identifier for the credential.
    """

    org_id: typing_extensions.Annotated[str, FieldMetadata(alias="orgId")] = pydantic.Field()
    """
    This is the unique identifier for the org that this credential belongs to.
    """

    created_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="createdAt")] = pydantic.Field()
    """
    This is the ISO 8601 date-time string of when the credential was created.
    """

    updated_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="updatedAt")] = pydantic.Field()
    """
    This is the ISO 8601 date-time string of when the assistant was last updated.
    """

    authentication_session: typing_extensions.Annotated[
        Oauth2AuthenticationSession, FieldMetadata(alias="authenticationSession")
    ] = pydantic.Field()
    """
    This is the authentication session for the credential. Available for credentials that have an authentication plan.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the name of credential. This is just for your reference.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
